// Test the AODV Protocol
// George F. Riley.  Georgia Tech, Fall 2002

#include "simulator.h"
#include "application-aodv.h"
#include "star.h"
#include "ratetimeparse.h"
#include "validation.h"
#include "application-cbr.h"
#include "rng.h"

int main(int argc, char** argv)
{
  Validation::Init(argc, argv);
  Simulator s;

  Uniform startRNG(0, 0.1);
  Uniform peerRNG(0,  10);
	IPAddr_t firstIP = IPAddr("192.168.1.0");


  // Create a star topology
  Star b(10, IPAddr("192.168.1.0"));
  // Put an AODV application at the hub
  AODVApplication* a = new AODVApplication(b.GetHub());
  a->Start(0.0);  // Start at time 0
  for (Count_t i = 0; i < b.LeafCount(); ++i)
    { // Put an AODV app at each leaf
      AODVApplication* a = new AODVApplication(b.GetLeaf(i));
      a->Start((i+1.0));  // Start at ascending times

		  CBRApplication* cbr = (CBRApplication*)(b.GetLeaf(i))->AddApplication(
			          CBRApplication(firstIP + peerRNG.IntValue(), 1000, 1000));
			      cbr->Start(startRNG.Value()); 
    }



  s.Run();
}
