/*

* GTNetS provides a portable C++ class library for network simulations
*
* Copyright (C) 2003 George F. Riley
*
* No guarantees or warranties or anything are provided or implied in any way
* whatsoever.  Use this program at your own risk.  Permission to use this
* program for any purpose is given, as long as the copyright is kept intact.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

* Permission is hereby granted for any non-commercial use of this code

*/

/* Debugging Macros.
// George F. Riley, Georgia Tech, Summer 2000

// Debug is enabled with a bitmask, DEBUG_MASK
// Define DEBUG_MASK prior to calling debug.h
// If bit 0 is set, level 0 debugs are enabled.
// up to level 31.
//
// To completely remove all debug (more efficient)
// define NO_DEBUG prior to calling.
*/

#ifndef __DEBUG_H__
#define __DEBUG_H__

// Some qt includes define a DEBUG macro different from this one
#ifdef DEBUG
#undef DEBUG
#endif

#ifdef NO_DEBUG
#define DBG(x)
#define DEBUG(l,x)
#define DEBUG0(x)
#else
#ifndef DEBUG_MASK
#define DEBUG_MASK 0
#endif

#define DBM DEBUG_MASK

#define DBG(x) x
#define DEBUG(l,x) if((1<<l)&DBM) x 
#define DEBUG0(x)if(1&DBM) x 

#endif

#endif
