/*
 * Copyright (C) 2005 Boeing
 */

#ifndef OSPF6_MPR_H
#define OSPF6_MPR_H

#ifdef OSPF6_MANET_MPR_FLOOD
#include "ospf6d.h" //for boolean
#include "ospf6_interface.h"
#include "ospf6_neighbor.h"

void ospf6_calculate_relays(struct ospf6_interface *);

#ifdef OSPF6_MANET_MPR_TOPO_REDUC
void ospf6_relay_create(struct ospf6_interface *, u_int32_t,
			struct ospf6_neighbor *);
void ospf6_reset_adv_MPR_MPRS(struct ospf6_interface *);
void ospf6_refresh_relay_list(struct ospf6_interface *);
void ospf6_refresh_relay_selector_list(struct ospf6_interface *);
#else // OSPF6_MANET_MPR_TOPO_REDUC
void ospf6_relay_create(struct ospf6_interface *, u_int32_t);
#endif // OSPF6_MANET_MPR_TOPO_REDUC

void ospf6_relay_delete(struct ospf6_interface *, struct ospf6_relay *);

void ospf6_refresh_relay_selector(struct ospf6_neighbor *);
#if defined(OSPF6_MANET_MPR_ADJ_REDUC_OSPF_MPR)||defined(OSPF6_MANET_MPR_TOPO_REDUC)
struct ospf6_relay *
  ospf6_lookup_relay(struct ospf6_interface *, u_int32_t);
#endif //OSPF6_MANET_MPR_ADJ_REDUC_OSPF_MPR||OSPF6_MANET_MPR_TOPO_REDUC
struct ospf6_relay_selector *
  ospf6_lookup_relay_selector(struct ospf6_interface *, u_int32_t);
void ospf6_relay_selector_delete(struct ospf6_interface *, 
                                 struct ospf6_relay_selector *);
#endif //OSPF6_MANET_MPR_FLOOD
#endif /* OSPF6_MPR_H */

