//*********************************************************************
//
// AUTHOR:    George Papageorgiou <gpapag@eng.umd.edu>
//
// FILE:      udpAlert.h 
//
// DATE:      April 7, 2003
//
// PURPOSE:   A new UDP agent to be used with the alert spreading 
//            application for the DARPA-NMS project.
// 
//*********************************************************************


#ifndef _udpAlert_h
#define _udpAlert_h

#include "udp.h"
#include "cmnAlert.h"



// UdpAlertAgent Class definition

class UdpAlertAgent : public UDP {
public:
  UdpAlertAgent() : support_alertApp(0) {}
  virtual int supportalertApp() { return 1; }
  virtual void enablealertApp() { support_alertApp = 1; }
  // Use SendTo from base UDP Class
  // Use DataIndication from base UDP Class
protected:
  int support_alertApp;   // set to 1 if above is AlertApp
private:
  TargetVec_t targetList_;   // list of the target nodes
};

#endif
