eval 'exec perl -S $0 ${1+"$@"}'  # -*-Mode:Perl; perl-indent-level:8-*-
    if 0;

# This script calculates the overall throughput of application traffic
# in the the network. 
# 
use POSIX;

# Generic option-grabbing code
sub Getopt
{
	local($spec) = @_;      # name of variables to be initialized from %opt
	&Usage  if ($#ARGV < 0);
	while ($_ = $ARGV[0], /^-(\w+)/) {
		shift @ARGV;
		$key = $1;
		$opt{$key} = (index($spec, "$key:") >= 0) ? shift @ARGV : &Usage;
	}
}

sub Usage
{
        $0 =~ s/.*\/([^\/]+)$/$1/o;
        print <<EOF;
Usage:  $0 [-start_time] [-end_time] tracefile.tr 

tracefile.tr is a tcpdump with the -vv option set
 
This script does the following:
     -determines the amount of overhead 
     -determines the number of UDP packets sent and received

Options:
---------------
-start_time:  skip all data in the trace file before this time
-end_time:  skip all data in the trace file after this time

Default:
---------------
start_time = 1800
end_time = 3600
EOF
exit 1;
}

sub Finish
{
	print "Control-C... exiting parse.pl\n";
	exit 1;
}

########Default values#########
$time_flag = 0;
$start_time = 1800;
$end_time = 3600;

# Only put entries below here that require a value to be indexed
&Getopt("start_time:end_time:");
# Process options
while(($key, $value) = each(%opt)) {
	if ($key eq "start_time") {
		$start_time = $value;
	} elsif ($key eq "end_time") {
		$end_time = $value;
	} else {
		&Usage;
	}
}

$SIG{'INT'} = 'Finish';
# main loop
while (<>) {
	@trace = split;

	$time = $trace[1];
	next if ($time < $start_time);
	last if ($time > $end_time);	
	
	$event = $trace[0]; 
	$node = $trace[2];
	$int = $trace[4];

	#Event Tracing
	if ($event eq "e") {
		if ($trace[3] eq "num_nbr") {
			$delta_t = $trace[6];
			$num_neigh = $trace[4];
      $delta_t_total += $delta_t;
      $change_node_sec += $delta_t;
      $neigh_node += $num_neigh * $delta_t;
			$num_change++;
      if($node{$node} == 0) {
        $node{$node} = 1;
        $num_nodes++;
			}
			if ($trace[8] eq "newnbr") {
				$newadjacency++;
			} else {
				$lifetime += $trace[11];
				$lifetime_num++;
				#printf("%f\n", $lifetime/($lifetime_num));
			}
		}
		elsif ($trace[3] eq "LSA_DATABASE") {
			$numDBdiffs++;
			$DBdiff += $trace[6];						
		}
		elsif ($trace[3] eq "unicast_LSU") {
			$rxmt_lsu += $trace[8];
			$dbexch_lsu += $trace[12];
			if ($trace[8] > 0 && $trace[12] > 0) {
				$rxmt_lsu += 20;  #half of the ip header and ospf header
				$dbexch_lsu += 20;
			} elsif ($trace[8] > 0) {
				$rxmt_lsu += 40; #ip header and ospf header
			}else {
				$dbexch_lsu += 40; #ip header and ospf header
			}
		}
	}
	
	next if ($event ne "s" && $event ne "r" && 
		$event ne "f" && $event ne "d");

	$src = $trace[10];
	$dest = $trace[12];
	$proto = $trace[18];
	$len = $trace[14];
	$id = $trace[6];
	
#printf("time %s event %s src %s dest %s proto %s len %i\n",
#                  $time, $event, $src, $dest, $proto, $len);
    
#udp data
if ($event eq "r" && $proto =~ /UDP/) {
	$udp_recv += $len;
	$udp_recv_pkt++;
	$hops{$id} = -1 * ($hops{$id} + 1);
} elsif ($event eq "s" && $proto =~ /UDP/) {
	$udp_send += $len;
	$udp_send_pkt++;
	$hops_index[$hops_num++] = $id;
} elsif ($event eq "f" && $proto =~ /UDP/) {
	$udp_fwd += $len;
	$udp_fwd_pkt++;
	$hops{$id}++;
}
#PROBLEM HERE  -- THESE SHOULD BE DROP NO ROUTES AS IN QUALNET
#elsif ($proto =~ /UDP/ && $_ =~ /IP_DROP_NOROUTE_SEND/) {
elsif ($event eq "d" && $proto =~ /UDP/) {
#These drops are sends when no routes exists
	$udp_send += $len;
	$udp_send_pkt++;
	$hops_index[$hops_num++] = $id;
} #elsif ($proto =~ /UDP/ && $_ =~ /IP_DROP_NOROUTE_FWD/) {
#	$hops{$id}++;
#}

# Routing packet type analysis
	$route = $proto =~ /OSPFv3/;
	next if (!$route || $event eq "r" || $event eq "d");
	
	$type = $trace[20];
	if ($proto =~ /OSPFv3/) {
		$ospf += $len;
		$ospf_pkt++;
		if ($type eq "HELLO") {
			$hello += $len;
			$hello_pkt += 1;
		} elsif ($type =~ /DBDESC/) {
			$dd += $len;
			$dd_pkt += 1;
		} elsif ($type =~ /LSR/) {
			$lsr += $len;
			$lsr_pkt += 1;
		} elsif ($type =~ /LSU/) {
			$lsu += $len;
			$lsu_pkt += 1;
			if ($dest ne "224.0.0.5") {
				$u_lsu+=$len;
				$u_lsu_pkt++;
			}
		} elsif ($type =~ /LSAck/) {
			$lsa += $len;
			$lsa_pkt += 1;
		} 
	}
}

# Print out section
$duration = $end_time-$start_time;

$del_ratio = (($udp_send_pkt > 0) ? $udp_recv_pkt/$udp_send_pkt : 0);

for ($i=0; $i < $hops_num; $i++) {
	if ($hops{$hops_index[$i]} < 0) {
		$avg_hops += $hops{$hops_index[$i]} * -1;
		$avg_hops_num++;
		#printf("%d\n", $hops{$hops_index[$i]} * -1 - 2);
	} else {
		$avg_failed_hops += $hops{$hops_index[$i]};
		$avg_failed_hops_num++;
	}

}
$avg_hops = ($avg_hops_num > 0 ? $avg_hops/$avg_hops_num : 0);
$avg_failed_hops = ($avg_failed_hops_num > 0 ? 
                              $avg_failed_hops/$avg_failed_hops_num : 0);

printf("\nStart time: %d End time: %d duration: %d\n", 
                   $start_time, $end_time, $duration);

	printf("             | Packets          Bytes         Kbps\n");
	printf("-------------------------------------------------------\n");
	printf("Hello        |%8d %14d %12.2f\n", 
		$hello_pkt, $hello, ($hello * 8/1000)/$duration);
	printf("LSAck        |%8d %14d %12.2f\n", 
		$lsa_pkt, $lsa, ($lsa * 8/1000)/($duration));
	printf("LSR          |%8d %14d %12.2f\n", 
		$lsr_pkt, $lsr, ($lsr * 8/1000)/($duration));
	printf("DBDESC       |%8d %14d %12.2f\n", 
		$dd_pkt, $dd, ($dd * 8/1000)/($duration));
	printf("LSU          |%8d %14d %12.2f\n", 
		$lsu_pkt, $lsu, ($lsu * 8/1000)/($duration));
	printf("  LSUfld     |  %8d %14d %12.2f\n", 
		$lsu_pkt-$u_lsu_pkt, $lsu-$u_lsu, (($lsu-$u_lsu) * 8/1000)/($duration));
	printf("  LSUuni     |  %8d %14d %12.2f\n", 
		$u_lsu_pkt, $u_lsu, ($u_lsu * 8/1000)/($duration));
	printf("    LSUrxmt  |        -    %14d %12.2f\n", 
		$rxmt_lsu, ($rxmt_lsu * 8/1000)/($duration));
	printf("    LSUdbexch|        -    %14d %12.2f\n", 
		$dbexch_lsu, ($dbexch_lsu * 8/1000)/($duration));
	printf("             |\n"); 
	printf("Total        |%8d %14d %12.2f\n", 
		$ospf_pkt, $ospf, (8 * $ospf/1000)/($duration));
	
	printf("\nDelivery Ratio: %1.2f; Avg Hops: %1.2f; Avg Failed Hops: %1.2f\n",
		$del_ratio, $avg_hops, $avg_failed_hops);
#############USER TRAFFIC PRINTOUT###################
print "\nUser Traffic analysis\n--------------\n";
printf "UDP_sent  pkts: %8d bytes: %d\n", $udp_send_pkt, $udp_send;
printf "UDP_recv  pkts: %8d bytes: %d\n", $udp_recv_pkt, $udp_recv;
printf "UDP_fwd  pkts: %8d bytes: %d\n",  $udp_fwd_pkt,  $udp_fwd;


##############NETWORK CHARACTERISTICS#############
$change_node_sec = ($change_node_sec > 0 ? $num_change/$change_node_sec : 0);
$neigh_node = ($delta_t_total > 0 ? $neigh_node/($delta_t_total) : 0);
$lifetime = ($lifetime_num > 0 ? $lifetime/$lifetime_num : 0);
$newadjrate = ($duration*$num_nodes>0 ? $newadjacency/($duration*$num_nodes):0);
$LSAsOutSync =  ($numDBdiffs > 0 ? $DBdiff/$numDBdiffs : 0);

printf("\nNetwork Characteristics\n---------------\n");
printf("neighbors/node: %.2f\n", $neigh_node);
printf("neighbor_changes/node/sec: %.2f\n", $change_node_sec);
printf("avg_sec/neighbor_life: %.2f\n", $lifetime);
printf("new_adjacencies/node/sec: %.2f\n", $newadjrate);
printf("avg_LSAsOutSync: %.2f\n", $LSAsOutSync);
