eval 'exec perl -S $0 ${1+"$@"}'  # -*-Mode:Perl; perl-indent-level:8-*-
    if 0;

# This script calculates the overall throughput of application traffic
# in the the network. 
# 
use POSIX;

# Generic option-grabbing code
sub Getopt
{
	local($spec) = @_;      # name of variables to be initialized from %opt
	&Usage  if ($#ARGV < 0);
	while ($_ = $ARGV[0], /^-(\w+)/) {
		shift @ARGV;
		$key = $1;
		$opt{$key} = (index($spec, "$key:") >= 0) ? shift @ARGV : &Usage;
	}
}

sub Usage
{
        $0 =~ s/.*\/([^\/]+)$/$1/o;
        print <<EOF;
Usage:  $0 [-start_time] [-end_time] tracefile.tr 

tracefile.tr is a tcpdump with the -vv option set
 
This script does the following:
     -determines the amount of overhead 
     -determines the number of UDP packets sent and received

Options:
---------------
-start_time:  skip all data in the trace file before this time
-end_time:  skip all data in the trace file after this time

Default:
---------------
start_time = 1800
end_time = 3600
EOF
exit 1;
}

sub Finish
{
	print "Control-C... exiting parse.pl\n";
	exit 1;
}

########Default values#########
$time_flag = 0;
$start_time = 1800;
$end_time = 3600;

# Only put entries below here that require a value to be indexed
&Getopt("start_time:end_time:");
# Process options
while(($key, $value) = each(%opt)) {
	if ($key eq "start_time") {
		$start_time = $value;
	} elsif ($key eq "end_time") {
		$end_time = $value;
	} else {
		&Usage;
	}
}

$SIG{'INT'} = 'Finish';

  $Sends = 0;
  $Trans = 0;
  $Rec = 0;

  $Sends_U = 0;
  $Sends_M = 0;
  $Trans_U = 0;
  $Trans_M = 0;
  $Rec_U = 0;
  $Rec_M = 0;

  #Hello
  $Sends_Hello = 0;
  $Trans_Hello = 0;
  $Rec_Hello = 0;
  
  #LSU_Unicast
  $Sends_LSU_U = 0;
  $Trans_LSU_U = 0;
  $Rec_LSU_U = 0;

  #LSU_Multicast
  $Sends_LSU_M = 0;
  $Trans_LSU_M = 0;
  $Rec_LSU_M = 0;

  #UDP
  $Sends_UDP = 0;
  $Trans_UDP = 0;
  $Rec_UDP = 0;

# main loop
while (<>) {
	@trace = split;

	$time = $trace[1];
	next if ($time < $start_time);
	last if ($time > $end_time);	
	
	$event = $trace[0]; 
	$node = $trace[2];
	$int = $trace[4];
	$dest = $trace[12];
	$proto = $trace[18];
	$type = $trace[20];

  # Tracing only S, T, and R packets
	if ($event eq "S") {
    $Sends++;
    if ($dest =~ /^224/) {
      $Sends_M++;
      # Look for LSU_Multicast and Hello
      if ($type =~ /HELLO/) {
        $Sends_Hello++;
      } elsif ($type =~ /LSU/) {
        $Sends_LSU_M++;
      }
    } else {
      $Sends_U++;
      # Look for UDP and LSU_Unicast
      if ($proto =~ /UDP/) {
        $Sends_UDP++;
      } elsif ($type =~ /LSU/) {
        $Sends_LSU_U++;
      }
    }
  }
	if ($event eq "T") {
    $Trans++;
    if ($dest =~ /^224/) {
      $Trans_M++;
      # Look for LSU_Multicast and Hello
      if ($type =~ /HELLO/) {
        $Trans_Hello++;
      } elsif ($type =~ /LSU/) {
        $Trans_LSU_M++;
      }
    } else {
      $Trans_U++;
      # Look for UDP and LSU_Unicast
      if ($proto =~ /UDP/) {
        $Trans_UDP++;
      } elsif ($type =~ /LSU/) {
        $Trans_LSU_U++;
      }
    }
  }
	if ($event eq "R") {
    $Rec++;
    if ($dest =~ /^224/) {
      $Rec_M++;
      # Look for LSU_Multicast and Hello
      if ($type =~ /HELLO/) {
        $Rec_Hello++;
      } elsif ($type =~ /LSU/) {
        $Rec_LSU_M++;
      }
    } else {
      $Rec_U++;
      # Look for UDP and LSU_Unicast
      if ($proto =~ /UDP/) {
        $Rec_UDP++;
      } elsif ($type =~ /LSU/) {
        $Rec_LSU_U++;
      }
    }
  }
}
    
# Print out section
$duration = $end_time-$start_time;

printf("\nStart time: %d End time: %d duration: %d\n\n",
                   $start_time, $end_time, $duration);
printf("\"Drops\" are (Transmits - Receives)\n\n");
                                                                                
	printf("             | Sends   Transmits   Receives  Drops     %%Drop\n");
	printf("----------------------------------------------------------------\n");
  printf("All packets  |%8d %8d %8d %8d %10.3f\n", $Sends, $Trans, $Rec, ($Trans - $Rec), (1-($Rec/$Trans))*100);
  printf("             |\n");
  printf("All unicast  |%8d %8d %8d %8d %10.3f\n", $Sends_U, $Trans_U, $Rec_U, ($Trans_U - $Rec_U), (1-($Rec_U/$Trans_U))*100);
  printf("All multicast|%8d %8d %8d %8d %10.3f\n", $Sends_M, $Trans_M, $Rec_M, ($Trans_M - $Rec_M), (1-($Rec_M/$Trans_M))*100);
  printf("             |\n");
  printf("HELLO        |%8d %8d %8d %8d %10.3f\n", $Sends_Hello, $Trans_Hello, $Rec_Hello, ($Trans_Hello - $Rec_Hello), (1-($Rec_Hello/$Trans_Hello))*100);
  printf("LSU_multicast|%8d %8d %8d %8d %10.3f\n", $Sends_LSU_M, $Trans_LSU_M, $Rec_LSU_M, ($Trans_LSU_M - $Rec_LSU_M), (1-($Rec_LSU_M/$Trans_LSU_M))*100);
  printf("LSU_unicast  |%8d %8d %8d %8d %10.3f\n", $Sends_LSU_U, $Trans_LSU_U, $Rec_LSU_U, ($Trans_LSU_U - $Rec_LSU_U), (1-($Rec_LSU_U/$Trans_LSU_U))*100);
  printf("UDP (data)   |%8d %8d %8d %8d %10.3f\n", $Sends_UDP, $Trans_UDP, $Rec_UDP, ($Trans_UDP - $Rec_UDP), (1-($Rec_UDP/$Trans_UDP))*100);
	
	printf("\nNodes had %1.2f average reception partners (possible neighbors in range)\n", $Trans/$Sends);
