eval 'exec perl -S $0 ${1+"$@"}'  # -*-Mode:Perl; perl-indent-level:8-*-
    if 0;

# This script passes through an out.tr file and prints out 
#
# Note:  Because packet hops may be interleaved, this involves one pass 
# through the file to determine all the unique packet IDs, then must pass
# through once per packet to trace out its lifetime

sub Getopt
{
        local($spec) = @_;      # name of variables to be initialized from %opt
        &Usage  if ($#ARGV < 0);
        while ($_ = $ARGV[0], /^-(\w+)/) {
                shift @ARGV;
                $key = $1;
                $opt{$key} = (index($spec, "$key:") >= 0) ? shift @ARGV : 1;
        }

}

sub Usage
{
        $0 =~ s/.*\/([^\/]+)$/$1/o;
        print <<EOF;
Usage:  $0 [-node NODE] [-id ID] <test>.tr

Prints out packet path traces for UDP packets.


EOF
        exit 1;
}

$SIG{'INT'} = 'Finish';
sub Finish
{
   exit 1;
}

&Getopt("node:id:trace:");
$opt_node = $opt{'node'};
$opt_id = $opt{'id'};
# $opt_trace = $opt{'trace'} ? $opt{'trace'} : Usage;
# open(INFILE, $opt_trace) || die "Bad tracefile $opt_trace -- $!";


$filename = shift; # filename should be sitting on @ARGV
open(INFILE, $filename) || die "Bad tracefile $filename -- $!";

$delayfile = "delays.dat";
$dropfile = "drops.dat";

open(DELAYS, '>', $delayfile) || die "cannot create out $!";
open(DROPS, '>', $dropfile) || die "cannot create out $!";


#
# Preprocessing-- pass through trace file and gather matching packet IDs
#
while (<INFILE>) {
        # Push all matching packet IDs onto non-unique list
        if (/^s/ && /UDP/) {
                ($pktid) = /pkt_id (\w*)/;
                ($node) = /N(\d+)/;
                if ($opt_node ne "" && $node == $opt_node) {
                    if ($opt_id ne "" && $pktid == $opt_id) {
                        # Both node, id specified
                        push(@nonuniq, $pktid);
                    } elsif ($opt_id eq "") {
                        # node specified, id unspecified
                        push(@nonuniq, $pktid);
                    }
                } elsif ($opt_node eq "") {
                    # node unspecified, id specified or unspecified
                    push(@nonuniq, $pktid);
                }
        }
}
# Now compress the list, removing non-unique values
%seen = ();
foreach $item (@nonuniq) {
	push(@uniq, $item) unless $seen{$item}++;
}
print "Processing ", $#uniq, " packets...\n";

#
# Main processing-- pass through trace file once per packet (slow...)
#
open(INFILE, $filename);
$start_time = 0;
$end_time = 0;
$end_found = 1;
$where_to_start = 0;
while ($cur = shift(@uniq)) {
	seek(INFILE,$where_to_start,0);
	if ($start_time != 0 && $end_found == 0) {
		print " (VANISHED)\n";
	}
	# Initialize variables
	$start_time = 0;
	$end_time = 0;
	$end_found = 0;
  $hops = 2;
	while ($line = <INFILE>) {
		$line =~ /pkt_id (\w*)/;
		$pktid = $1;
		if ($cur eq $pktid) {
			# We've found a line for our packet
			if (!$start_time && $line =~ /^s/) {
				$line =~ /s (\w*.\w*) N(\d+)/;
				$start_time = $1;
				$where_to_start = tell(INFILE);
				printf "PktId %s starttime %.3f path: %d-", $cur, $start_time, $2;
        $start_node = $2;
			} elsif (!$start_time && $line =~ /^d/) {
				$line =~ /d (\w*.\w*) N(\d*)/;
				$start_time = $1;
				
				printf "PktId %s starttime %.3f path: %d (DROPPED)\n", $cur, $start_time, $2;
				printf DROPS "%.3f\n", $start_time;
				$end_found = 1;
				last; # We're done with this packet
			} elsif ($line =~ /^d/) {
				$line =~ /d (\w*.\w*) N(\d*)/;
				print "$2 (DROPPED)\n";
				$end_found = 1;
				printf DROPS "%.3f\n", $start_time;
				last; # We're done with this packet
			} elsif ($line =~ /^r/) {
				$line =~ /r (\w*.\w*) N(\d*)/;
				printf("%d    e2e-delay: %.3f\n", $2, $1 - $start_time);
				$end_found = 1;
        $hopcount[$hops]++;
				if ($hops >= 5) {
          printf("XXX 5 hops for $cur:  $start_time $start_node\n");
        }
				printf DELAYS "%.3f %.3f\n", $start_time, $1 - $start_time;
				last; # We're done with this packet
			} elsif ($line =~ /^f/) {
				$line =~ /f (\w*.\w*) N(\d*)/;
				print "$2-";
        $hops++;
			}
		}
	}
}
print "\n";
for ($i=0; $i<=$#hopcount; $i++) {
  $j = $i-1;
  if ($hopcount[$i]) {
    print "Hops: $j, Occurrences: $hopcount[$i]\n";
  }
}

close(DELAYS);
close(DROPS);
