eval 'exec perl -S $0 ${1+"$@"}'  # -*-Mode:Perl; perl-indent-level:8-*-
    if 0;

# This script calculates the overall throughput of application traffic
# in the the network. 
# 
use POSIX;
use Env;  #Environment Variables


# Generic option-grabbing code
sub Getopt
{
	local($spec) = @_;      # name of variables to be initialized from %opt
	&Usage  if ($#ARGV < 0);
	while ($_ = $ARGV[0], /^-(\w+)/) {
		shift @ARGV;
		$key = $1;
		$opt{$key} = (index($spec, "$key:") >= 0) ? shift @ARGV : &Usage;
	}
}

sub Usage
{
        $0 =~ s/.*\/([^\/]+)$/$1/o;
        print <<EOF;
Usage:  $0 [-xnorm <>] [-ynorm <>] 
           [-start <>] [-stop <>] 
           [-delay <>] tracefile.tr 

 
This script creates an animated gif file of the OSPF-MDR topology.
NOTE:  One must compile gifmerge in bin/gifmerge for this script to function.

Parameter Description
--------------
-tracefile.tr: GTNetS trace with topology information included. 
-xnorm:  the width of the topology
-ynorm:  the length of the topology
-start:  skip all data in the trace file before this time
-stop:   skip all data in the trace file after this time
-delay:  delay between gif frames in msecs.

Default:
---------------
ynorm = xnorm = 500;
start = 1800
stop = 3600
delay = 300;
EOF
exit 1;
}

sub Finish
{
  print "Control-C... exiting tracetoppms.pl\n";
  exit 1;
}

########Default values#########
$time_flag = 0;
$start = 1800;
$stop = 3600;
$xnorm = 500;
$ynorm = 500;
$delay = 100;

# Only put entries below here that require a value to be indexed
&Getopt("start:stop:xnorm:ynorm:delay:");
# Process options
while(($key, $value) = each(%opt)) {
  if ($key eq "start") {
    $start = $value;
  } elsif ($key eq "stop") {
    $stop = $value;
  } elsif ($key eq "xnorm") {
    $xnorm = $value;
  } elsif ($key eq "ynorm") {
    $ynorm = $value;
  } elsif ($key eq "delay") {
    $delay = $value;
  } else {
    &Usage;
  }
}


$incr_time = 0;
$dir = "tmp.anim";
system ("mkdir -p $dir");

$SIG{'INT'} = 'Finish';
# main loop
while (<>) {
  @trace = split;

  $time = $trace[1];
  next if ($time < $start);
  last if ($time > $stop);	
	
  $event = $trace[0]; 
  $node = $trace[2];
 
  next if (!($event eq "n" || $event eq "a" || $event eq "b"));

  if ($event eq "n") {
    $n_xcoord = $trace[4];
    $n_ycoord = $trace[6];
    $n_mdr = $trace[8];
    $n_bmdr = $trace[10];
    if ($time != $incr_time) {
      $incr_time = $time;
      
      $number = Number($count);
      close(FNODES); close (MDR); close (FMBDR); close(DRADJ); close(OTHERADJ);
      open(FNODES, "> ".$dir."/fnodes".$number.".loc") || 
        die "cannot create *.loc: $!";
      open(MDR,   "> ".$dir."/mdr".$number.".loc") || 
        die "cannot create *.loc: $!";
      open(BMDR,  "> ".$dir."/bmdr".$number.".loc") || 
        die "cannot create *.loc: $!";
      open(DRADJ,   "> ".$dir."/dradj".$number.".loc") || 
        die "cannot create *.loc: $!";
      open(OTHERADJ,   "> ".$dir."/otheradj".$number.".loc") || \
        die "cannot create *.loc: $!";
      $count++;
    }
    printf(FNODES "%f %f\n", $n_xcoord/$xnorm, $n_ycoord/$ynorm);
    if ($n_mdr) {
      printf(MDR "%f %f\n", $n_xcoord/$xnorm, $n_ycoord/$ynorm);
    } elsif ($n_bmdr) {
      printf(BMDR "%f %f\n", $n_xcoord/$xnorm, $n_ycoord/$ynorm);
    }
  } elsif ($event eq "a") {
    $b_xcoord = $trace[8];
    $b_ycoord = $trace[10];
    printf(OTHERADJ "%f %f\n", $n_xcoord/$xnorm, $n_ycoord/$ynorm);
    printf(OTHERADJ "%f %f\n\n", $b_xcoord/$xnorm, $b_ycoord/$ynorm);
  } elsif ($event eq "b") {
    $a_xcoord = $trace[8];
    $a_ycoord = $trace[10];
    printf(DRADJ "%f %f\n", $n_xcoord/$xnorm, $n_ycoord/$ynorm);
    printf(DRADJ "%f %f\n\n", $a_xcoord/$xnorm, $a_ycoord/$ynorm);
  }
}

open (GNUPLOT, "> ".$dir."/gnuplot.txt") || die "cannot create gnuplot.txt: $!";
printf (GNUPLOT "
set terminal pbm small color
#set terminal windows
#set data style lines
set size 1.0, 1.0
#set format y \"\%g\"
#set samples 1000
set xrange [0 : 1]
set yrange [0 : 1]
#set autoscale y

#set noxtics
#set noytics
set xtics 0, .1, 10
set ytics 0, .1, 10

set style line 1 lt 1 lw 3  #red, width 7 line
set style line 2 lt 0 lw 1  #grey, width 1 line
set style line 3 lt -1 lw 1 #black, width 1 line
set grid ls 2 
 
#set title \"OSPF-MDR with 100 Nodes for 120sec of Simulation Time\"
set key
#set nokey
#set pointsize 1.5
#set xlabel \"packet rate per source\"
#set ylabel \"delay (sec)\"
#set boxwidth 0.9 relative
set boxwidth 0.1
#set style fill solid 1.0  (need version 4)\n");

for ($i = 1; $i < $count; $i++) {
  $number = Number($i);
  printf (GNUPLOT "set output \"%s/b%s.ppm\"\n", $dir, $number);
  printf (GNUPLOT "plot \"%s/otheradj%s.loc\" with lines lt 0 lw 1 title 'Other Router Adjacency', ", $dir, $number);
  printf (GNUPLOT "\"%s/dradj%s.loc\" with lines lt 1 lw 4 title '(B)MDR Adjacenecy', ", $dir, $number);
  printf (GNUPLOT "\"%s/fnodes%s.loc\" with points lt 0 pt 3 ps 3 title 'Other Router', ",
          $dir, $number);
  printf (GNUPLOT "\"%s/mdr%s.loc\" with points lt 1 pt 3 ps 3 title 'MDR Router', ", 
          $dir, $number);
  printf (GNUPLOT "\"%s/bmdr%s.loc\" with points lt 12 pt 3 ps 3 title 'BMDR Router'\n", 
          $dir, $number);
}

system("gnuplot $dir/gnuplot.txt");

for ($i = 1; $i < $count; $i++) {
		$number = Number($i);
  $ppm = "b".$number.".ppm";
  $gif= "b".$number.".gif";
  system("ppmtogif $dir/$ppm > $dir/$gif");
#  system("gifrsize -s 0.9 $dir/$gif > $dir/$gif");
}

system("rm anim.gif");
system("$GTNETS_HOME/bin/gifmerge/gifmerge -$delay -l0 $dir/*.gif > anim.gif");

system("rm -rf $dir");

#system("display anim.gif&");


############SUBROUTINES###############

sub Number()
{
  my($count) = 0;
  my($i) = $_[$count]; $count++;
  my($number);

    if ($i < 10) {
    $number = "0000".$i;
  } elsif ($i < 100) {
    $number = "000".$i;
  } elsif ($i < 1000) {
    $number = "00".$i;
  } elsif ($i < 10000) {
    $number = "0".$i;
  } else {
    $number = $i;
  }
  return $number;
}
