eval 'exec perl -S $0 ${1+"$@"}'  # -*-Mode:Perl; perl-indent-level:8-*-
if 0;
use POSIX;
use Switch;
use Env;  #Environment Variables
		
#
# Runs the simulation script for different configurations (foreach loop)
# 
# For each configuration, runs simulation for $number times, starting 
# from base seed $baseseed, so that multiple runs may be averaged
#
# Note:  If you make the outer loop the repetitive one for looping
#        across different seeds, then you can guarantee that you have
#        at least some runs with each configuration if you have to 
#        abort execution early

$dir_rwp =  $GTNETS_HOME."/ietf/random_waypoint_manet";
$output = "output";
$test="random_waypoint_manet";

#Basic config
$start_time=1800;
$stop_time=2700;
# no trace, etrace, osfpv3log, tag=args

#Data traffic config
$pktsize=40;
$pktrate=10;

#Scenario config
$radio_range = 250;
$alpha = 0.5;
$pause_time = 40;

#Mac config
$mac_protocol = 0;

#OSPFv3 config
$HelloInterval = 2;
$DeadInterval = 6;
$RxmtInterval = 5;
$MinLSInterval = 5;
$MinLSArrival = 1;
$AckInterval = 1800;

#MPR MANET config
$PushbackInterval = 2000;

#MDR MANET config
$TwoHopRefresh = 3;
$AdjConnectivity = 0; # 0=fully connected, 1=uniconnected, 2=biconnected
$LSAFullness = 3; # 0=min, 1=min-hop, 2=M(B)DR full LSAs, 3=full LSAs
$BackupWaitInterval = 2000;
$NonPersistentMDR = ""; #"NonPersistentMDR";

$num_seeds=4;
$baseseed=72;
@num_nodes = (10,20,30,40,50);
@velocity=(5, 20);
@grid_length=(500, 707);
@w_int=("PTMP","OR","MDR");
@diff_hellos = (""); #("","diff_hellos");


if(0) {
#create directories
foreach $w_int(@w_int) {
foreach $num_nodes (@num_nodes) {
foreach $velocity(@velocity) {
foreach $grid_length(@grid_length) {
  $dir_output = $dir_rwp."/".
         $output."/".
         $w_int."/".
         "nodes-".$num_nodes."/".
         "velocity-".$velocity."/".
         "grid-".$grid_length;
  system("mkdir -p $dir_output");
} #w_int
} #num_nodes
} #velocity
} #grid_length

for($index = 0; $index < $num_seeds; $index++) {
  $seed = $baseseed + $index;
  foreach $num_nodes(@num_nodes) {
  foreach $velocity(@velocity) {
  foreach $grid_length(@grid_length) {
  foreach $w_int(@w_int) {
  foreach $diff_hellos(@diff_hellos) {

		if ($w_int eq "OR") {
    $wireless_interface = 2;
    $wireless_flooding =1;
    $tag = "OR";
    if ($diff_hellos eq "diff_hellos") {
      $tag .= ".diff_hellos";
    }
		} elsif ($w_int eq "MDR") {
    $wireless_interface = 2;
    $wireless_flooding =2;
    $tag = "MDR";
    switch ($AdjConnectivity) {
      case 0  {$tag .= ".full"}
      case 1  {$tag .= ".uni"}
      case 2  {$tag .= ".bi"}
    }
    switch ($LSAFullness) {
      case 0  {$tag .= ".min"}
      case 1  {$tag .= ".minhop"}
      case 2  {$tag .= ".mdr"}
      case 3  {$tag .= ".full"}
    }
    if ($diff_hellos eq "diff_hellos") {
      $tag .= ".diff_hellos";
    }
		} else {
    $wireless_interface = 1;
    $wireless_flooding =0;
    $tag = "PTMP";
    if ($diff_hellos eq "diff_hellos") {
      next;
    }
		}
  
  $tag .= ".".$seed;

  $cmd_input = 
             " seed=".$seed.
             " num_nodes=".$num_nodes.
             " tag=".$tag.
             " pktrate=".$pktrate.
             " wireless_interface=".$wireless_interface.
             " wireless_flooding=".$wireless_flooding.
             " velocity=".$velocity.
             " grid_length=".$grid_length.
             " radio_range=".$radio_range.
             " pause_time=".$pause_time.
             " HelloInterval=".$HelloInterval.
             " RxmtInterval=".$RxmtInterval.
             " DeadInterval=".$DeadInterval.
             " AckInterval=".$AckInterval.
             " PushbackInterval=".$PushbackInterval.
             " BackupWaitInterval=".$BackupWaitInterval.
             " TwoHopRefresh=".$TwoHopRefresh.
             " AdjConnectivity=".$AdjConnectivity.
             " LSAFullness=".$LSAFullness.
             " ".$NonPersistentMDR.
             " ".$diff_hellos.
             " start_time=".$start_time.
             " stop_time=".$stop_time;

  $dir_output = $dir_rwp."/".
         $output."/".
         $w_int."/".
         "nodes-".$num_nodes."/".
         "velocity-".$velocity."/".
         "grid-".$grid_length;

  system("$dir_rwp/$test-opt $cmd_input >> $dir_rwp/$test-opt-$tag.log");
  system("mv $dir_rwp/$test.$tag.stat $dir_output");


  } #diff_hellos
  } #w_int
  } # grid_length
  } # velocity
  } #num_nodes
} #seed
} #if ()

foreach $num_nodes(@num_nodes) {
foreach $velocity(@velocity) {
foreach $grid_length(@grid_length) {
foreach $w_int(@w_int) {
foreach $diff_hellos(@diff_hellos) {

  if ($w_int eq "OR") {
    $wireless_interface = 2;
    $wireless_flooding =1;
    $tag = "OR";
    if ($diff_hellos eq "diff_hellos") {
      $tag .= ".diff_hellos";
    }
  } elsif ($w_int eq "MDR") {
    $wireless_interface = 2;
    $wireless_flooding =2;
    $tag = "MDR";
    switch ($AdjConnectivity) {
      case 0  {$tag .= ".full"}
      case 1  {$tag .= ".uni"}
      case 2  {$tag .= ".bi"}
    }
    switch ($LSAFullness) {
      case 0  {$tag .= ".min"}
      case 1  {$tag .= ".minhop"}
      case 2  {$tag .= ".mdr"}
      case 3  {$tag .= ".full"}
    }
    if ($diff_hellos eq "diff_hellos") {
      $tag .= ".diff_hellos";
    }
  } else {
    $wireless_interface = 1;
    $wireless_flooding =0;
    $tag = "PTMP";
    if ($diff_hellos eq "diff_hellos") {
      next;
    }
  }

  $dir_output = $dir_rwp."/".
         $output."/".
         $w_int."/".
         "nodes-".$num_nodes."/".
         "velocity-".$velocity."/".
         "grid-".$grid_length;

  $file=$test.".".$tag;

#printf("%s %s\n", $dir_output, $file);

  system("cd $dir_output; $GTNETS_HOME/bin/statistics.pl -both $file*.stat; mv mean.out mean_$file.out");


} #diff_hellos
} #w_int
} # grid_length
} # velocity
} #num_nodes
