# $Id: qtcheck.mk,v 1.1.1.1 2006/12/13 13:09:35 dnguyen Exp $

ifndef QTDIR
# some brain-dead distros may have a potpourri
ifeq ($(findstring qt.h, $(wildcard /usr/include/*)), qt.h)
ifeq ($(findstring libqt.so, $(wildcard /usr/lib/*)), libqt.so)
       HAVE_QT    =    1
       MOC        =    /usr/bin/moc
       CFLAGS    +=   -DHAVE_QT
       QT_INCL    =   -I/usr/include
       QT_LIBS    =   -L/usr/lib -lqt
endif
endif

# debian has them here
ifeq ($(findstring qt.h, $(wildcard /usr/include/qt3/*)), qt.h)
ifeq ($(findstring libqt.so, $(wildcard /usr/lib/qt3/*)), libqt.so)
       HAVE_QT    = 1
       MOC        =    /usr/bin/moc
       CFLAGS    +=   -DHAVE_QT
       QT_INCL    =   -I/usr/include/qt3
       QT_LIBS    =   -L/usr/lib/qt3 -lqt -Wl,--rpath -Wl,/usr/lib/qt3
endif
ifeq ($(findstring libqt.so, $(wildcard /usr/lib/*)), libqt.so)
       HAVE_QT    = 1
       MOC        =    /usr/bin/moc
       CFLAGS    +=   -DHAVE_QT
       QT_INCL    =   -I/usr/include/qt3
       QT_LIBS    =   -L/usr/lib -lqt
endif
endif

# freebsd has them here
ifeq ($(findstring qt.h, $(wildcard /usr/local/include/*)), qt.h)
ifeq ($(findstring libqt.so, $(wildcard /usr/local/lib/*)), libqt.so)
       HAVE_QT    = 1
       MOC        =   /usr/local/bin/moc
       CFLAGS    +=   -DHAVE_QT
       QT_INCL    =   -I/usr/local/include
       QT_LIBS    =   -L/usr/local/lib -lqt -Wl,--rpath -Wl,/usr/local/lib
endif
endif

# QT from troll tech installs in a separate directory
ifeq ($(findstring qt.h, $(wildcard /usr/local/qt3/include*)), qt.h)
ifeq ($(findstring libqt.so, $(wildcard /usr/local/qt3/lib/*)), libqt.so)
       HAVE_QT   = 1
       MOC       =  /usr/local/bin/moc
       CFLAGS   +=  -DHAVE_QT
       QT_INCL   =  -I/usr/local/include/qt3
       QT_LIBS   =  -L/usr/local/lib/qt3/lib -lqt -Wl,--rpath -Wl,/usr/local/lib/qt3/lib
endif
endif

# redhat has QTDIR defined but just in case its not ??
ifeq ($(findstring qt.h, $(wildcard /usr/lib/qt3/include/*)), qt.h)
ifeq ($(findstring libqt.so, $(wildcard /usr/lib/qt3/lib/*)), libqt.so)
       HAVE_QT   = 1
       MOC       = /usr/lib/qt3/bin/moc
       CFLAGS   += -DHAVE_QT
       QT_INCL   = -I/usr/lib/qt3/include
       QT_LIBS   = -L/usr/lib/qt3/lib -lqt-mt -Wl,--rpath -Wl,/usr/lib/qt3/lib
endif
endif

# fedora nuances, moved qt to yet another place QTDIR is not defined
ifeq ($(findstring qt.h, $(wildcard /usr/lib/qt-3.1/include/*)), qt.h)
ifeq ($(findstring libqt.so, $(wildcard /usr/lib/qt-3.1/lib/*)), libqt.so)
	HAVE_QT   = 1
	MOC       = /usr/lib/qt-3.1/bin/moc
	CFLAGS    += -DHAVE_QT
	QT_INCL   = -I/usr/lib/qt-3.1/include
	QT_LIBS   = -L/usr/lib/qt-3.1/lib -lqt -Wl,--rpath -Wl,/usr/lib/qt-3.1/lib
endif
endif

# MacOS X doesn;t have QTDIR defined if qt3 is installed from fink
# Note:: this is not the native macos X it is the one built on x11
ifeq ($(findstring qt.h, $(wildcard /sw/include/qt/*)), qt.h)
ifeq ($(findstring libqt-mt.dylib, $(wildcard /sw/lib/*)), libqt-mt.dylib)
       HAVE_QT   = 1
       MOC       = /sw/bin/moc
       CFLAGS   += -DHAVE_QT
       QT_INCL   = -I/sw/include/qt
       QT_LIBS   = -L/sw/lib -lqt-mt
endif
endif

else
       HAVE_QT   = 1
       MOC       = $(QTDIR)/bin/moc
       CFLAGS   += -DHAVE_QT
       QT_INCL   = -I$(QTDIR)/include
       QT_LIBS   = -L$(QTDIR)/lib -lqt -Wl,--rpath -Wl,$(QTDIR)/lib
endif

# this target is for debugging
#checkqt:
#	echo $(MOC) ; \
#	echo $(CFLAGS) ; \
#	echo $(QT_INCL) ; \
#	echo $(QT_LIBS) ;
